/*

    Zelda Oni Link Begins

    Copyright (C) 2006-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __COMMON_H__
#define __COMMON_H__

#define CASE    16          // taille d'une case en pixel

#define ANIM_REFRESH    120     // intervale entre les anims

#include <sstream>
#include <iostream>
#include <fstream>

#include <SDL/SDL.h>
#include <SDL_image/SDL_image.h>

#include "OSXport.h"

using namespace std;

enum Direction {N, S, O, E};

enum Collision { VIDE = -1, LIBRE = 0, PLEIN = 1, SEMI_PLEIN = 2, BAS = 3, 
    HAUT = 4, DROITE = 5, GAUCHE = 6, BAS_DROITE = 7, BAS_GAUCHE = 8, 
    HAUT_DROITE = 9, HAUT_GAUCHE = 10, BOIS = 11, EAU = 12, GLACE = 13};
    
enum Type_Anim {AUCUNE, MARCHE, EPEE, SPIN, NAGE, ARC, GRAPPIN, BOMBE, BFEU, BGLACE,
    LANTERNE, MARTEAU, JOUE, BOIRE, NOYADE, FLOTTE, LOURD, SOULEVE, PORTE, EMMENE, TOUCHE,
    LANCE, POUSSE, CHUTE, MORT};

enum Type_Attaque {COUP_EPEE, EPEE_SPIN, FLECHE, COUP_GRAPPIN, FEU, COUP_GLACE, PROJECTILE,
    EXPLOSION,COUP_MARTEAU, POT, CAISSE, MAGIE, ENNEMI, LAPIN, RETOUR, DEMI, VENIN, HYMNE_VIDE,
    CHANT_ESPRIT, COLERE, ASPIRE, MORTEL};

enum Type_Def {CRAINT, X2, RESISTE, INVUL};

enum Type_Objets {O_ARC, O_GRAPPIN, O_SAC_BOMBES, O_BFEU, O_BGLACE, O_LANTERNE,
    O_MARTEAU, O_PALMES, O_GANTS, O_LIVRE, O_BOTTES, O_CARTE, O_ENCYCL, O_OCARINA, O_MASQUE};

enum Type_Items {I_RIEN, I_RUBIS_VERT, I_RUBIS_BLEU, I_RUBIS_ROUGE, I_PETIT_COEUR, 
    I_FLECHE, I_BOMBE, I_MAGIE_PEU, I_MAGIE_BCP, I_QUART_COEUR, I_EPEE, I_CRISTAL,
    I_EXCALIBUR, I_PETITE_CLE, I_TRIFORCE, I_ARC, I_COEUR};

enum Type_Contenu {C_RIEN = 0, C_BOUCLIER = 225, C_EPEE = 131, C_QUART_COEUR = 3, C_BOTTES = 7,
    C_BOUTEILLE = 46, C_CARTE=132, C_BOUSSOLE=133, C_CLE_BOSS=134, C_CLE=135, C_GANTS=147, 
    C_CRISTAL=137, C_BOUCLIER_R=78, C_GRAPPIN=157, C_LANTERNE=230, C_PALMES=165, C_MARTEAU=156, 
    C_BFEU=175, C_BGLACE=179, C_EXCALIBUR=260, C_TRIFORCE=195, C_LIVRE=98, C_MEDAILLON=102, 
    C_MIMAGIE=228, C_POTION_ROUGE=335, C_POTION_VERTE=336, C_POTION_BLEUE=337,C_ARC=151,
    C_PAIE=303, C_EPEE_R=177, C_GANTS_R=240, C_ARC_FEE=194, C_COEUR=136, C_SAC_BOMBES=146,
    C_TUNIQUE_BLEUE=166, C_TUNIQUE_ROUGE=167, C_OCARINA=229, C_MASQUE=231, C_BOUCLIER_J=180,
    C_MASQUE_ONI=183, C_HYMNE_VIDE=357, C_CHANT_ENVOL=390, C_CHANT_ESPRIT=378};

enum Type_IA {IA_RIEN, IA_FONCE, IA_SNIPE, IA_ATTEND, IA_RANDOM, IA_SUIT, IA_HAUT_BAS, 
    IA_SPECIAL, IA_STATUE};

enum Type_Ennemi {E_SIMPLE, E_MONO_DIR, E_PROFIL};

enum Type_Pnj {P_SIMPLE, P_MONO_DIR, P_PROFIL};
    
#endif  // Common.h
